__author__ = 'enayat'

import nltk, logging, re, os
from gensim.models import Word2Vec
from nltk.corpus import stopwords, brown
from string import punctuation
from gensim.corpora import WikiCorpus
import math, pycrfsuite
import scipy.spatial as spatial
from nltk.corpus import sentiwordnet as sw
from corenlp import *
from nltk.corpus import wordnet as wn
import ast, cPickle

sentiWordNet_ThreshHold =0.5



sentiWords = ['happy', 'sad','']  # sentiWords with polarity > sentiment threshold
# corenlp = StanfordCoreNLP()  # wait a few minutes...

class Content(object):
    def __init__(self, text, target, category, polarity, label,words,stobject):
        self.text = text
        self.target = target
        self.category = category
        self.polarity = polarity
        self.label = label
        self.words=words
        self.stobject=stobject

class Sentence(object):
    def __init__(self):
        self.sentence = []

    def add_sentence(self, text, target, category, polarity, label,words,stobject):
        self.sentence.append(Content(text, target, category, polarity, label,words,stobject))


class Review(object):
    def __init__(self):
        self.review = []


    def add_review(self):
        self.review.append(Sentence())


def parse(flie_name):
	
	rev = Review()
	file = open(flie_name, "r+")
	k = 0
	l = 0
	char1 = ">"
	char2 = "<"
	para = ""
	para1 = []
	lines = file.readlines()
	for i in range(1, len(lines)):
		line = lines[k]
		k = k + 1
		line = line.lstrip()
		if "Review rid" in line:
		    rev.add_review()
		    for j in range(k, len(lines)):
		        line = lines[k]
		        k = k + 1
		        line = line.lstrip()
		        line = line.rstrip("\r\n")
		        line = line.rstrip("\r\n")
		        if "sentence id" in line:
		            # print "sent"
		            line = lines[k]
		            line = line.lstrip()
		            line = line.rstrip("\r\n")
		            line = line.rstrip("\r\n")
		            text = line[line.find(">") + 1: line.find("</")]
		            k = k + 2
		            target = ""
		            polarity = ""
		            category = ""
		            flag = 0
		            for m in range(k, len(lines)):
		                line = lines[k]
		                line = line.lstrip()
		                line = line.rstrip("\r\n")
		                line = line.rstrip("\r\n")
		                if "<Opinion" in line:
		                    line = line.split("\"")
		                    # print line
		                    # print line[1]
		                    if (flag == 0):
		                        target = line[1]
		                        category = line[3]
		                        polarity = line[5]
		                    else:
		                        target = target + ":" + line[1]
		                        category = category + ":" + line[3]
		                        polarity = polarity + ":" + line[5]
		                    k = k + 1
		                    flag = 1
		                else:
		                    break
		            para = para + text
		            # text = text.lower()
		            # text = text.rstrip(".")
		            text = removePunctuationsFromSentence(text)
		            # text1 = text.split()
		            text1,st=sent2Words(text)
		            para1.append(text1)
		            # newtarget=target.rsplit(":| ")
		            newtarget = re.split(":| ", target)
		            label = []
		            for x in xrange(0, len(text1)):
		                if text1[x] in newtarget:
		                    label.extend("1")
		                else:
		                    label.extend("0")
		            # print newtarget
		            rev.review[l].add_sentence(text, target, category, polarity, label,text1,st)
		        if "</Review>" in line:
		            # rev.add_review()
		            l += 1
		            break
		if (k == len(lines)):
		    break
	array2d = []
	for i in range(0, len(para1)):
	    array2d.append([])
	    array2d[i].extend(para1[i])
	return rev


def trainFromWikiEng(file, model_name, num_features):
    logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', \
                        level=logging.INFO)
    wiki = WikiCorpus(file)
    # Set values for various parameters
    num_features = num_features  # Word vector dimensionality
    min_word_count = 40  # Minimum word count
    num_workers = 4  # Number of threads to run in parallel
    context = 10  # Context window size
    downsampling = 1e-3  # Downsample setting for frequent words

    # Initialize and train the model (this will take some time)
    print "Training Word2Vec model..."
    model = Word2Vec(workers=num_workers, \
                     size=num_features, min_count=min_word_count, \
                     window=context, sample=downsampling, seed=1)
    sentences = wiki.get_texts()
    model.build_vocab(sentences)
    sentences = wiki.get_texts()
    model.train(sentences, chunksize=500)
    model.save(model_name)


def train(num_features, sentences, model_name):
    logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', \
                        level=logging.INFO)

    # Set values for various parameters
    num_features = num_features  # Word vector dimensionality
    min_word_count = 40  # Minimum word count
    num_workers = 4  # Number of threads to run in parallel
    context = 10  # Context window size
    downsampling = 1e-3  # Downsample setting for frequent words

    # Initialize and train the model (this will take some time)
    print "Training Word2Vec model..."
    model = Word2Vec(sentences, workers=num_workers, \
                     size=num_features, min_count=min_word_count, \
                     window=context, sample=downsampling, seed=1)

    # If you don't plan to train the model any further, calling
    # init_sims will make the model much more memory-efficient.
    model.init_sims(replace=True)

    # It can be helpful to create a meaningful model name and
    # save the model for later use. You can load it later using Word2Vec.load()
    model.save(model_name)
    return model

def isTheWordCapitalizedOrHyphened(word):
	if(len(word)>1):
		firstLetter = word[0]
		if firstLetter.isupper():
			return 1
		elif word.find('-') is not -1:
			return 1
	return 0

def nMostCommonFromCorpus(n, corpus):
    return 1

def extractFromCorenlpParse(line,text):
	# line=corenlp.parse(sent)
	# print line
	m=-1
	dependencies=[]
	namedentity=[]
	lemma=[]
	line = ast.literal_eval(line)
	# text=sent2words(line["sentences"][0]["text"])
	# print "teri  maa ka\n\n",text
	for i in range(len(text)):
		dependencies.append([])	
		namedentity.append([])
		lemma.append([])
	for i in range(1,len(line['sentences'][0]['dependencies'])):
		# try:
		m=text.index(line['sentences'][0]['dependencies'][i][1])
		dependencies[m].append(str(line['sentences'][0]['dependencies'][i][2]))
		# except:
			# continue
		# print m
		
	# print dependencies
	# print len(line['sentences'][0]['words'][:])
	for i in range(0,len(line['sentences'][0]['words'])):
		namedentity[i]=line['sentences'][0]['words'][i][1]['NamedEntityTag']
		lemma[i]=line['sentences'][0]['words'][i][1]['Lemma']
	# print namedenity
	# print lemma
	return dependencies,namedentity,lemma

def remove_nonSentiWord( word ):

    shouldInclude = False
    if len(list(sw.senti_synsets(word))) == 0:
        # print word, " not in sentiWordNet"
        if len(list(wn.synsets(word))) == 0:
            # print word, " not in wordNet"
            shouldInclude = False
        else:
            shouldInclude = True
    else:
        synSet = list(sw.senti_synsets(word))
        # print "Word: ", word
        for item in synSet:
            # print "+ ", item.pos_score(), " - ", item.neg_score(), " Neutral ", item.obj_score()
            if item.pos_score() > sentiWordNet_ThreshHold or item.neg_score() > sentiWordNet_ThreshHold:
                shouldInclude = True
                break
    return shouldInclude

def stanfordFeatures(stanfordObject,words):
    # info=corenlp.parse(sent.text)
    dependency,ner,lemma=extractFromCorenlpParse(stanfordObject,words)
    return dependency, ner, lemma


def removePunctuationsFromList(sents):
    exclude = set(punctuation)
    exclude.remove('\'')
    filteredSents = []
    for sent in sents:
        filteredSent = []
        for word in sent:
            filteredWord = ''.join(ch for ch in word if ch not in exclude)
            if filteredWord != '':
                filteredSent.append(filteredWord)
        filteredSents.append(filteredSent)

    return filteredSents


def OldremovePunctuationsFromSentence(sent):
    # exclude = set(punctuation)
    # exclude.remove('\'')
    # filteredSent=''
    # for word in sent:
    #     filteredWord = ''.join(ch for ch in word if ch not in exclude)
    #     if filteredWord != '':
    #         filteredSent=filteredSent+' '+filteredWord
    # return filteredSent

    # print "sent",sent

    return ' '.join(filter(None, (word.strip(punctuation) for word in sent.split())))

def removePunctuationsFromSentence(string):
    string=string.replace(",", " ").replace('#',' ').replace("/"," ").replace("\""," ").replace(";"," ").replace("!"," ").replace("("," ").replace(")"," ").replace("*"," ").replace("@"," ").replace("$"," ").replace("+"," ").replace("_"," ").replace("%"," ").replace(">"," ").replace("<"," ").replace("' "," ").replace(" '"," ").replace("?"," ").replace("."," ")
    return string

def POStagsOfSent(sent, option):
    # OPTION 1: A single sentence
    # OPTION 2: List of list of sentences
    if option == 1:
        words = nltk.word_tokenize(sent)
    posTags = nltk.pos_tag(words)
    return posTags


def euclideanNorm(vec):
    sum = 0
    for v in vec:
        sum = sum + (v ** 2)
    return math.sqrt(sum)


def cosineDis(vec1, vec2):
    # print vec1,vec2


    return spatial.distance.cosine(vec1, vec2)
    # numerator=0
    #  l = len(vec1)
    #  for i in range(0,l):
    #      numerator = numerator + (vec1[i]*vec2[i])
    #  sum1 = euclideanNorm(vec1)
    #  sum2 = euclideanNorm(vec2)
    #  denominator = math.sqrt(sum1) * math.sqrt(sum2)
    #
    #  if not denominator:
    #     return 0.0
    #  else:
    #     return float(numerator) / denominator


def sentToVec(sent, model):
    filteredSent = removePunctuationsFromSentence(sent)
    words = nltk.word_tokenize(filteredSent)
    sentVec = 0
    for words in sent:
        sentVec = sentVec + model[words.lower()]
    return sentVec


def accuracy(label_new, label_orgnl):
    length=len(label_orgnl[:])
    conf_matrix=[[0,0],[0,0]]
    for x in xrange(0,length):
        count_orgnl=label_orgnl[x]
        count_new=label_new[x]
        for a in range(0,len(count_new)):
            if (count_new[a]=="1") and (count_orgnl[a]=="1"):
                conf_matrix[0][0]+=1
            elif (count_new[a]=="1") and (count_orgnl[a]=="0"):
                conf_matrix[0][1]+=1
            elif (count_new[a]=="0") and (count_orgnl[a]=="1"):
                conf_matrix[1][0]+=1
            elif (count_new[a]=="0") and (count_orgnl[a]=="0"):
                conf_matrix[1][1]+=1
    precision=float(conf_matrix[0][0])/float((conf_matrix[0][0]+conf_matrix[1][0]))
    recall= float(conf_matrix[0][0])/float((conf_matrix[0][0]+conf_matrix[0][1]))
    accur= float((conf_matrix[0][0]+conf_matrix[1][1]))/float((conf_matrix[0][0]+conf_matrix[0][1]+conf_matrix[1][0]+conf_matrix[1][1]))
    f1=2*(float(precision*recall)/float(precision+recall))
    return precision,recall,accur, f1


def featuresForTarget(words, i, addInfoOfWords, model, domainCentroid):
    ''' addInfoOfWords:
        addInfoOfWords[i][0] = pos Tag of word
        addInfoOfWords[i][1] = Named Entity
        addInfoOfWords[i][2] = Dependent on what word
        addInfoOfWords[i][3] = Lemma of the word
        addInfoOfWords[i][4] = Is it dependent on an optinion word
        addInfoOfWords[i][5] = Nearest distance to a domain word
      '''
    domain=['place','waiter','dish','food','staff','service','price','ambience','restaurant','dessert','wine','waitress']
    word=words[i]
    lemma=addInfoOfWords[i][3]
    try:
        mod = model[word.lower()]
    except:
        print "Unknown Word",word
    try:
        mod = model[lemma.lower()]
    except:
         print "Unknown Lemma",lemma
         mod=model["unknown"]
    addInfoOfWords[i][5]= nearestDistanceFromSet(mod,model,domain)
    features = {}
    features['word'] = word
    features['alwayson'] = True
    features["POS tag"] = addInfoOfWords[i][0]
    features["Distance to Domain Centroid"] = cosineDis(mod, domainCentroid)
    features["named entity"] = addInfoOfWords[i][1]
    features["dependent on an opinion word"] = addInfoOfWords[i][4]
    features['Nearest distance to a domain word']= addInfoOfWords[i][5]
    features['Capitalized Word']= addInfoOfWords[i][6]
    # features["label of previous word"]=prevlabel
    features['word position']=i
    if i<1:
    	features['n_gram']=" ".join(word[i:i+1])
    else:
    	features['n_gram']=" ".join(word[i-1:i+1])
 



    # features = [
    # 'POS tag='+addInfoOfWords[i][0],
    #     'Distance to Laptop Centroid=%f' %cosineDis(model[words[i]],domainCentroid),
    #     'named entity=%r'%addInfoOfWords[i][1]
    # ]

    if (i > 0):
        word1 = words[i - 1]
        lemma1=addInfoOfWords[i-1][3]
        try:
            mod = model[word1.lower()]
        except:
            print "Unknown Word",word1
        try:
            mod = model[lemma1.lower()]
        except:
             print "Unknown Lemma",lemma1
             mod=model["unknown"]
        addInfoOfWords[i-1][5] = nearestDistanceFromSet(mod,model,domain)
        features['-1:word'] = word1
        features['-1:POS tag'] = addInfoOfWords[i - 1][0]
        features["-1:Distance to Domain Centroid"] = cosineDis(mod, domainCentroid)
        features["-1:named entity"] = addInfoOfWords[i-1][1]
        features["-1:dependent on an opinion word"] = addInfoOfWords[i-1][4]
        features['-1:Nearest distance to a domain word']= addInfoOfWords[i-1][5]
        features['-1:Capitalized Word']= addInfoOfWords[i-1][6]
        # features["-1:label of previous word"]=label[i-2]

    else:
        features['BOS']=True

    if i<len(words)-1:
        word1 = words[i + 1]
        lemma1=addInfoOfWords[i+1][3]
        try:
            mod = model[word1.lower()]
        except:
            print "Unknown Word",word1
        try:
            mod = model[lemma1.lower()]
        except:
             print "Unknown Lemma",lemma1
             mod=model["unknown"]
        addInfoOfWords[i+1][5]= nearestDistanceFromSet(mod,model,domain)
        features['+1:word'] = word1
        features['+1:POS tag'] = addInfoOfWords[i + 1][0]
        features["+1:Distance to Domain Centroid"] = cosineDis(mod, domainCentroid)
        features["+1:named entity"] = addInfoOfWords[i+1][1]
        features["+1:dependent on an opinion word"] = addInfoOfWords[i+1][4]
        features['+1:Nearest distance to a domain word']= addInfoOfWords[i][5]
        features['+1:Capitalized Word']= addInfoOfWords[i+1][6]
        # features["+1:label of previous word"]=label[i-2]
    else:
        features["EOS"]=True

    return features

def polarityOfWord(word):
    positive,negative,neutral=remove_nonSentiWord(word)
    s=float(max(positive,negative,neutral))
    if positive==s:
        return "1"
    elif negative==s:
        return "-1"
    else:
        return "0"

def nearest_adjective(words,partofpeech,aspect):
    m=words.index(apect)
    low=min(len(words)-m,m)
    for i in range(0,low):
        if(partofpeech[m-i][1]=="JJ"):
            return words[m-i]
        elif(partofpeech[m+i][1]=="JJ"):
            return  words[m+i]
    return "0"

def featuresForPolarity(sent,aspectWord, model, addInfo):
    # filteredSent = removePunctuationsFromSentence(sent)
    # words = nltk.word_tokenize(filteredSent)
    ''' addInfo[0] = POS Tag of aspect
    	addInfo[1] = Nearest adjective
    	addInfo[2] = Polarity of adjective

    '''

    words = sent.words
    print "words", words
    features = {}
    # features['alwayson'] = True
    # features['word feature'] = [word for word in words]
    features['aspectWord']=aspectWord
    i=0
    for w in words:
    	st ="%d Word" % i
    	features[st]=w 
    	i=i+10
    features['distance from happy'] = cosineDis(model[addInfo[1].lower()], model["happy"])
    features['distance from sad'] = cosineDis(model[addInfo[1].lower()],model['sad'])
    features['Polarity of adjective']= addInfo[2]
    features['POS tag of aspect'] = addInfo[0]
    features['Nearest Adjective'] = addInfo[1]
    # features['euclideanNorm of Adjective']=euclideanNorm(model[addInfo[1]])
    features['Is aspect word dependent on an opinion word'] = addInfo[3]



    # features['nearest adjective'] = addInfo[0] 
    # features['nearest adjective polarity'] = addInfo[1]		# +1,-1,or 0

    return features




def oldSent2words(sent):
    filteredSent = removePunctuationsFromSentence(sent)
    words = nltk.word_tokenize(filteredSent)
    # words=sent.split()
    return words
def str2Obj(str):
    return ast.literal_eval(str)

def sent2Words(sent):
    token=[]
 
    stanfordObject = corenlp.parse(sent)
    line= str2Obj(stanfordObject)
    print line
    for i in range(0, len(line['sentences'][0]['words'])):
        token.append([])
    for i in range(0, len(line['sentences'][0]['words'])):
        # print "saa"
        token[i]= line['sentences'][0]['words'][i][0]
    return token,stanfordObject


def trainBrownAll():
    cat = brown.categories()
    sents = brown.sents(categories=cat)
    sents = removePunctuationsFromList(sents)
    return train(200, sents, "brown_all")

def calcDomainCentroid(model, op):
    domain=['place','waiter','dish','food','staff','service','price','ambience','restaurant','dessert','wine','waitress']
    v=[0]*100 
    for d in domain: 
    	v=v+model[d.lower()] 
    return v/12

def isTheWordDepOnOpinionWord(depList):
    for word in depList:
        # if word in sentiWords:
        #     return '1'
        if remove_nonSentiWord(word):
            return 1
    return 0

def nearestDistanceFromSet(mod,model,domain):
	# domain=['place','waiter','dish','food','staff','service','price','ambience','restaurant','dessert','wine','waitress']
	m=100000
	for d in domain:
		modD=model[d.lower()]
		dis=cosineDis(mod,modD)
		if(dis<m):
			m=dis
	# print "min dis",m
	return m



def sent2features(sent, model,domainCentroid):
    ''' addInfoOfWords:
    addInfoOfWords[i][0] = pos Tag of word
    addInfoOfWords[i][1] = Named Entity
    addInfoOfWords[i][2] = Dependent on what word
    addInfoOfWords[i][3] = Lemma of the word
    addInfoOfWords[i][4] = Is it dependent on an optinion word
    addInfoOfWords[i][5] = Nearest distance to word in domain
    '''
    # words,stanfordObject = sent2Words(sent.text)
    words=sent.words
    stObject=sent.stobject
    print words
    posTags = nltk.pos_tag(words)
    dependency,ne,lemma = stanfordFeatures(stObject,words)
    # ne = [False for i in range(len(words))]
    addInfo = []
    for i in range(len(words)):
        depOnOpinion = isTheWordDepOnOpinionWord(dependency[i])
        # nearestDis= nearestDisfromDomain(model,words[i])
        nearestDis=0
        if ne[i]!='0':
        	ne[i]=1
        else:
        	ne[i]=0
        info = [posTags[i][1], ne[i],dependency[i],lemma[i],depOnOpinion,nearestDis,isTheWordCapitalizedOrHyphened(words[i])]
        addInfo.append(info)
    return [featuresForTarget(words, i, addInfo, model, domainCentroid) for i in range(len(words))]

def sent2labels(sent):
    return [label for label in sent.label]

def sent2Pfeatures(sent, model, domainCentroid):
    ''' addInfoOfWords:
    addInfoOfWords[i][0] = nearest adjective
    addInfoOfWords[i][1] = adjective polarity
    addInfoOfWords[i][2] = If aspect is Dependent on that word
    addInfoOfWords[i][3] = Lemma of the word
    addInfoOfWords[i][4] = 
    addInfoOfWords[i][5] = Nearest distance to word in domain
    '''
    # words,stanfordObject = sent2Words(sent.text)
    words=sent.words
    stObject=sent.stobject
    # print "WORDS",words
    posTags = nltk.pos_tag(words)
    dependency,ne,lemma = stanfordFeatures(stObject,words)
    if sent.target != 'NULL' and sent.target!='':
    	print "target", sent.target
    	print "text", sent.text
    	sent.target=sent.target.lower()
    	if (sent.target).find(' '):
    		tar=(sent.target).split(' ')[0]
    	try:
    		indexOfAspect = words.index(tar)
    		depOnOpinion = isTheWordDepOnOpinionWord(dependency[indexOfAspect])
    		lem=lemma[indexOfAspect]
    		pos=posTags[indexOfAspect][1]
    		print "pos",pos
    		dep=dependency[indexOfAspect]
    		adj = nearest_adjective(words,posTags,tar)
    		adjPolarity = polarityOfWord(adj)
    	except:
    		lem ='0'
    		dep='0'
    		depOnOpinion=0
    		pos='0'
    		adj='0'
    		adjPolarity='0'
    else:
    	lem ='0'
    	dep='0'
    	depOnOpinion=0
    	pos='0'
    	adj='0'
    	adjPolarity='0'
  
    addInfo = [pos,adj,adjPolarity,depOnOpinion,dep,lem]
    # addInfo.append(info)
    return featuresForPolarity(sent,sent.target,model, addInfo)


def sent2Plabels(sent):
    return  sent.polarity

def trainCRF(x_train, y_train,trainerName):
    trainer = pycrfsuite.Trainer(verbose=False)
    for xseq, yseq in zip(x_train, y_train):
        trainer.append(xseq, yseq)

    trainer.set_params({
        'c1': 1.0,  # coefficient for L1 penalty
        'c2': 1e-3,  # coefficient for L2 penalty
        'max_iterations': 50,  # stop earlier

        # include transitions that are possible, but not observed
        'feature.possible_transitions': True
    })

    trainer.train('savedCRF')

def testCRF(trainerName,testSents,model,domainCentroid):
    predictedLabels=[]
    tagger = pycrfsuite.Tagger()
    tagger.open(trainerName)
    for sent in testSents:
        sent.text=sent.text.lower()
        sent.text = removePunctuationsFromSentence(sent.text)
        feat=sent2features(sent,model,domainCentroid)
        label = tagger.tag(feat)
        predictedLabels.append(label)
    return predictedLabels

def removeStopWordsFromWords(words):
	# words=sent.words
	# print words
	stops = stopwords.words('english')
	nostop = [word for word in words if not word in stops]
	s=' '.join(nostop)
	return nostop, s


def words2Vec(words,model):
	# words,s=removeStopWordsFromWords(words)
	# print "words",words
	vec = [0]*100
	k=0
	for w in words:
		try:
			mod = model[w.lower()]
			vec=vec+mod
			k=k+1
		except:
			print "Unknown Word---",w," Skip"
		

	return (vec/k)

def minDisFromSentiWord(sentVec):
	for word in sentiWords:
		nearestDistanceFromSet(sentVec,)

def repeatSents(sents):
	newSents=[]
	for sent in sents:
		if sent.target =='':
			continue
		targets = sent.target.split(':')
		polarities=sent.polarity.split(':')
		categories=sent.category.split(':')
		for i in range(len(targets)):
			s = Sentence()
			s.text=sent.text
			s.target=targets[i]
			s.category=categories[i]
			s.polarity=polarities[i]
			s.label=sent.label
			s.words=sent.words
			s.stobject=sent.stobject
			newSents.append(s)
		# print s.words
	return newSents	

def pol_accuracy(polarity_orgnl,polarity_prdctd):
    accrcy=0
    correct=0
    conf_matrix=[[0,0,0],[0,0,0],[0,0,0]]
    for i in range(0,len(polarity_orgnl)):
        if polarity_orgnl[i]=="positive":
            if polarity_prdctd[i]=="positive":
                conf_matrix[0][0]+=1
            if polarity_prdctd[i]=="negative":
                conf_matrix[0][1]+=1
            if polarity_prdctd[i]=="neutral":
                conf_matrix[0][2]+=1
        elif polarity_orgnl[i]=="negative":
            if polarity_prdctd[i]=="positive":
                conf_matrix[1][0]+=1
            if polarity_prdctd[i]=="negative":
                conf_matrix[1][1]+=1
            if polarity_prdctd[i]=="neutral":
                conf_matrix[1][2]+=1
        else:
            if polarity_prdctd[i]=="positive":
                conf_matrix[2][0]+=1
            if polarity_prdctd[i]=="negative":
                conf_matrix[2][1]+=1
            if polarity_prdctd[i]=="neutral":
                conf_matrix[2][2]+=1
        if polarity_orgnl[i]==polarity_prdctd[i]:
            correct+=1
    precision=float(conf_matrix[0][0]+conf_matrix[1][1]+conf_matrix[2][2])/float(conf_matrix[0][0]+conf_matrix[1][1]+conf_matrix[2][2]+conf_matrix[0][2]+conf_matrix[1][2]+conf_matrix[2][2])
    recall=float(conf_matrix[0][0]+conf_matrix[1][1]+conf_matrix[2][2])/float(conf_matrix[0][0]+conf_matrix[1][1]+conf_matrix[2][2]+conf_matrix[2][0]+conf_matrix[2][1]+conf_matrix[2][2])
    accur_conf=float(conf_matrix[0][0]+conf_matrix[1][1]+conf_matrix[2][2])/float(sum(map(sum, conf_matrix)))
    accr =float(correct*100)/float(len(polarity_orgnl))
    return precision, recall, accur_conf, accr	

def main():
    trainXml = "ABSA-15_Restaurants_Train_Final.xml"
    testXml = "ABSA15_Restaurants_Test.xml"

    # trainReviews = parse(trainXml).review
    # with open("trainReviewsNew.dump", "wb") as output:
    # 	cPickle.dump(trainReviews, output, cPickle.HIGHEST_PROTOCOL)

    # Opening trainReviews from a file	
    with open("trainReviewsNew.dump", "rb") as input:
		trainReviews = cPickle.load(input)

    trainSents = []
    testSents = []
    crfName="savedCRF"
    for review in trainReviews:
        trainSents.extend(review.sentence)
    # Parsing testReviews and saving to a file    
    # testReviews=parse(testXml).review
    # with open("testReviewsNew.dump", "wb") as output:
    # 	cPickle.dump(testReviews, output, cPickle.HIGHEST_PROTOCOL)

    # Opening testReviews from a file
    with open("testReviewsNew.dump", "rb") as input:
		testReviews = cPickle.load(input)

    model = Word2Vec.load('vec_model')
    domainCentroid = calcDomainCentroid(model, 1)
    y_train = [sent2labels(s) for s in trainSents]
    x_train = [sent2features(s, model, domainCentroid) for s in trainSents]

    trainCRF(x_train,y_train,crfName)
    origLabels=[]
    for review in testReviews:
        testSents.extend(review.sentence)
        for sent in review.sentence:
            origLabels.append(sent.label)

    predictedLabels=testCRF(crfName,testSents,model,domainCentroid)
    for i in range(len(predictedLabels)):
        print testSents[i].text
        print "Predicted",predictedLabels[i]
        print "Original ",origLabels[i]
    precision,recall,accur, f1 = accuracy(predictedLabels,origLabels)
    print "p",precision,"r",recall,"a",accur,"f1",f1


    # # Sentiment Analysis:

    # # noStopTrainSents=[]
    # # for sent in trainSents:
    # # 	words,text = removeStopWordsFromSent(sent)
    # # 	s= Sentence(text,sent.target,s.category,sent.polarity,sent.label,words,sent.stobject)
    # # 	s = sentence(sent.text,targets[i], categories[i], polarities[i], sent.label,sent.words,sent.stobject)
    # # 	noStopTrainSents.append(s)
    # # repeatTrainSents= repeatSents(noStopTrainSents)




    repeatTrainSents= repeatSents(trainSents)
    P_train_positive = [(sent2Pfeatures(s, model,domainCentroid),"positive") for s in repeatTrainSents if s.polarity=="positive"]
    P_train_negative = [(sent2Pfeatures(s, model,domainCentroid),"negative") for s in repeatTrainSents if s.polarity=="negative"]
    P_train_neutral = [(sent2Pfeatures(s, model,domainCentroid),"neutral") for s in repeatTrainSents if s.polarity=="neutral"]

    poscutoff = len(P_train_positive)*1/2
    P_train_positive = P_train_positive[:poscutoff]
    # P_train_neutral.extend(P_train_neutral)

    polarityFeats = P_train_positive + P_train_negative + P_train_neutral
    print "Positive Length", len(P_train_positive)
    print "Negative Length", len(P_train_negative)
    print "Neutral Length", len(P_train_neutral)

    # Py_train = [sent2Plabels(s) for s in repeatTrainSents]
        


    # polarityFeats = [(featuresForPolarity(sent,model,addInfo),sent.polarity) for sent in repeatTrainSents]
    # polarityFeats = [(px,py) for px,py in zip(Px_train,Py_train)]

    print polarityFeats
    algorithm = nltk.classify.MaxentClassifier.ALGORITHMS[0]
    classifier = nltk.MaxentClassifier.train(polarityFeats, algorithm,max_iter=10)
    classifier.show_most_informative_features(10)

    repeatTestSents= repeatSents(testSents)
    Px_test = [sent2Pfeatures(s, model,domainCentroid) for s in repeatTestSents]
    i=0
    predictedPolarity=[]
    origPolarity=[]
    for pxT in Px_test:
    	prP=classifier.classify(pxT)
    	orP=repeatTestSents[i].polarity
    	predictedPolarity.append(prP)
    	origPolarity.append(orP)
    	print "Predicted: %s" % prP ,"Original: %s" % orP
    	i+=1
    print pol_accuracy(origPolarity,predictedPolarity)
main()

